/************************************************
              Class LinkedList

A minimal LinkedList class composed of Node objects
for 15-111/200 Mastery Exam/Fall 2002

You need to add a method to this class as described 
in the instructions. You may add additional helper 
(private) methods if you choose, but you may not 
add additional public methods, nor may you change
those methods that we have defined.

Name:
Section:
Date:
andrew e-mail:
*************************************************/
public class LinkedList
{
   private Node head;
   private int count;

/************************************************
 *  To the Student: Implement this method       *
 ************************************************/

   /**
    * Sort the list from least to greatest as 
    * dictated by the order given by compareTo()
    *
    */
   public void sort()
   {
     /*
      * Your code here
      */
   }

/************************************************
 *  To the Student: Nothing to do below         *
 ************************************************/


   /**
   *  Default constructor: sets head to null, count to 0
   */
   public LinkedList()
   {
      head = null;
      count = 0;
   }

   /**
   *  Returns the number of nodes in the list
   *  @return int the value of count
   */
   public int size()
   {
      return count;
   }

   /**
   *  Tests list to see if it is empty
   *  @return boolean: true if the list is empty
   */
   public boolean isEmpty()
   {
      return head == null;
   }

   /**
   *  Inserts a Comparable item at the beginning of the list
   *  @param Comparable item to be added into the LinkedList
   */
   public void addFirst(Comparable item)
   {
      Node newNode = new Node (item);
      newNode.setNext(head);
      head = newNode;
      count++;
   }

  
   /**
   *  Returns a string representation of the list
   *  @return String
   */
   public String toString()
   {
      String result = "";

      for (Node tmp = head; tmp != null; tmp = tmp.getNext( ))
      {
         result += tmp.toString() + System.getProperty("line.separator");
      }

      return result;
   }
}
